#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for(int i = a;i < (b);++i)
#define sz(x) (int)(x).size()
typedef vector<int> vi;

struct node{
    vector<int> children;
    int visited = 0;
};

int dfs(vector<node> &g, int s){
    g[s].visited = 1;
    int res = 0;
    int parent = 0;
    for(auto &v:g[s].children){
        if(!g[v].visited)
            res+=dfs(g, v);
        else{
            parent = 1;
        }
    }
    if(s==1)
        parent = 2;
    else{
        parent++;
    }

    int children_size = int(g[s].children.size()) - parent;
    res += max(0,  children_size);
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<node> g(n+1);
    for(int i=0;i<n-1;i++){
        int u,v;
        cin >> u >> v;
        g[u].children.push_back(v);
        g[v].children.push_back(u);
    }
    cout << dfs(g, 1) << endl;
    return 0;
}