//
// Created by cteam057 on 12/1/19.
//

#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for(int i = a;i < (b);++i)
#define sz(x) (int)(x).size()
typedef vector<int> vi;

struct UF{
    vi e;
    UF(int n): e(n, -1){
        number = n;
    }
    int number;

    int size(int x){return -e[find(x)];}
    int find(int x){
        return e[x] < 0 ? x : e[x] = find(e[x]);
    }

    void join(int a, int b){
        a = find(a), b =find(b);
        if(a==b) return;
        number--;
        if(e[a] > e[b]) swap(a,b);
        e[a] += e[b]; e[b] = a;
    }
    int get_number(){
        return number;
    }
};

struct node{
    vector<int> edges;
};


int main() {
    ios_base::sync_with_stdio(0);
    int n, e, p;
    cin >> n >> e >> p;
    vector<node> g(n+1);

    for(int i=0;i<e;i++){
        int u,v;
        cin >> u >> v;
        g[u].edges.push_back(v);
        g[v].edges.push_back(u);
    }

    for (auto &x: g) {
        sort(x.edges.begin(), x.edges.end());
    }

    for(int i=0;i<p;i++){
        int m;
        cin >> m;
        vector<int> t;
        t.reserve(m);
        for(int j=0;j<m;j++){
            int x;
            cin >> x;
            t.push_back(x);
        }
        unordered_map<int, int> index;
        sort(t.begin(), t.end());
        for(int j=0;j<t.size();j++){
            index[t[j]] = j;
        }
        UF uf = UF(t.size());

        if(t.size() <= sqrt(n)/3){
            for(int u=0;u<t.size();u++){
                for(int v=u+1;v < t.size();v++){
                    if(u ==v)
                        continue;
                    auto it = lower_bound(g[t[u]].edges.begin(), g[t[u]].edges.end(), t[v]);
                    if(it != g[t[u]].edges.end() && *it == t[v]) {
                        uf.join(u,v);
                    }
                }
            }
        } else{
            for(int j=0;j<t.size();j++){
                int u = t[j];
                for(auto &v:g[u].edges){
                    if(index.count(v)){
                        uf.join(j, index[v]);
                    }
                }
            }
        }
        cout << uf.get_number() << endl;
    }
    return 0;
}